"use strict";
/**
  Provide a type which is effectively a type-safe, non-interchangeable empty
  object to use instead of `null` or `undefined`.

  @module
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.Unit = void 0;
/**
  The `Unit` type exists for the cases where you want a type-safe equivalent of
  `undefined` or `null`. It's a concrete instance, which won't blow up on you,
  and you can safely use it with e.g. `Result` without being concerned that
  you'll accidentally introduce `null` or `undefined` back into your
  application.

  Equivalent to `()` or "unit" in many functional or functional-influenced
  languages.
 */
exports.Unit = Object.create(null);
exports.default = exports.Unit;
//# sourceMappingURL=unit.cjs.map